// JavaScript Document 多多

if((("createTouch" in document) || 'ontouchstart' in document.documentElement)==false){
	var MONIQI=1;
}
else{
	var MONIQI=0;
}

//--------------功能相关函数-----------------------//

/*
求对象长度
*/
function size(obj){
	var size = 0;
	for(var i in obj){
		size++;
	}
	return size;
}

/*
求时间戳
type：1精确到秒时间戳，2精确到毫秒的时间戳
*/
function time(type){
	type=type||1;
	if(type==1){
		var t=Date.parse(new Date())/1000;
	}
	else{
		var t=Date.parse(new Date());
	}
	return t;
}

/*
时间格式化
var myDate = new Date();
myDate.format(‘'YYYY-mm-dd HH:ii:ss');
*/
Date.prototype.format = function(format) {
    /*
  * eg:format="YYYY-mm-dd HH:ii:ss";
  */
  format=format||'YYYY-mm-dd HH:ii:ss';
    var o = {
        "m+": this.getMonth() + 1,
        //month
        "d+": this.getDate(),
        //day
        "H+": this.getHours(),
        //hour
        "i+": this.getMinutes(),
        //minute
        "s+": this.getSeconds(),
        //second
        "q+": Math.floor((this.getMonth() + 3) / 3),
        //quarter
        "S": this.getMilliseconds() //millisecond
    }

    if (/(Y+)/.test(format)) {
        format = format.replace(RegExp.$1, (this.getFullYear() + "").substr(4 - RegExp.$1.length));
    }

    for (var k in o) {
        if (new RegExp("(" + k + ")").test(format)) {
            format = format.replace(RegExp.$1, RegExp.$1.length == 1 ? o[k] : ("00" + o[k]).substr(("" + o[k]).length));
        }
    }
    return format;
}

/*
数据库类
*/
var LS = window.LS = {
	_dataName : 'mylocalstage',
	dbIsOpen:false,
	//打开数据库，并且只打开一次
	_openDataBase : function(){
		var me = this;
		if(me.dbIsOpen){
			return;
		}
		uexDataBaseMgr.cbOpenDataBase = function(opId,dataType,data){
			me.dbIsOpen = (dataType==2 && data==0);
			me._initTable();
		};
		uexDataBaseMgr.openDataBase(me._dataName,"");
	},
	_closeDataBase : function(){
		uexDataBaseMgr.closeDataBase(this._dataName,"")
	},
	//初始化数据表
	_initTable : function(){
		var me = this,
		_sql = 'CREATE TABLE IF NOT EXISTS data(_id INTEGER PRIMARY KEY,k TEXT,v TEXT)';
		me.exeSql(_sql);
	},
	/*
	执行一条SQL语句
	
	sql = SQL语句
	succCall = 成功时callback函数
	errCall = 失败时callback函数
	*/
	exeSql : function(sql,succCall,errCall){
		var me = this;
		me._index = (me._index||100)+1;
		me._callback = (me._callback||{});

		if(succCall || errCall){
			me._callback[me._index]={
				'succCall':succCall,
				'errCall':errCall
			};	
		}
		if(sql.toUpperCase().substr(0,6)=='SELECT'){
			uexDataBaseMgr.cbSelectSql = function(opId,dataType,data){
				data=JSON.parse(data);
				me._callback[opId] && me._callback[opId]['succCall'] && me._callback[opId]['succCall'](data);
			};
			uexDataBaseMgr.selectSql(me._dataName,me._index,sql)
		}
		else{
			//设置回调函数
			uexDataBaseMgr.cbExecuteSql=function(opId,dataType,data){
				if(dataType==2 && data==0){
					me._callback[opId] && me._callback[opId]['succCall'] && me._callback[opId]['succCall']();
				}else{
					me._callback[opId] && me._callback[opId]['errCall'] && me._callback[opId]['errCall']();	
				}
				delete me._callback[opId];
			};
			//执行sql语句
			uexDataBaseMgr.executeSql(me._dataName,me._index,sql);
		}
	},
	//获取一个值，获取成功后调用callback
	get : function(k,callback){
		LS._openDataBase();
		this.exeSql("SELECT * FROM data WHERE 1=1",callback);
	},
	//设置一个值，设置成功后调用callback
	set : function(k,v,callback){
		if(appcan.isPlainObject(v) || appcan.isArray(v)){
			v=JSON.stringify(v);
			v=v.replace(/"/g,'##');
		}
		LS._openDataBase();
		this.exeSql("DELETE FROM data WHERE k='"+ k +"'",callback);
		this.exeSql("INSERT INTO data (k,v) VALUES ('"+ k +"','"+ v +"')",callback);
	},
	unset : function(k,callback){
		LS._openDataBase();
		if(k!=''){
			this.exeSql("DELETE FROM data WHERE k='"+k+"'",callback);
		}
	}
};

/*
对象克隆
*/
function clone(obj){
	var o;
	switch(typeof obj){
	case 'undefined': break;
	case 'string'   : o = obj + '';break;
	case 'number'   : o = obj - 0;break;
	case 'boolean'  : o = obj;break;
	case 'object'   :
		if(obj === null){
			o = null;
		}else{
			if(obj instanceof Array){
				o = [];
				for(var i = 0, len = obj.length; i < len; i++){
					o.push(clone(obj[i]));
				}
			}else{
				o = {};
				for(var k in obj){
					o[k] = clone(obj[k]);
				}
			}
		}
		break;
	default:		
		o = obj;break;
	}
	return o;	
}

/*
存储数据
objName：名称
objValue：数值，可以是对象
cacheTime：存储时间，默认100年（就是永久啦~~~）
*/
function set(objName,objValue,cacheTime){
	//if(objValue==null){objValue='';}
	var _objName=objName;
	var _cacheTime=cacheTime;
	if(cacheTime==-1){
		cacheTime=0;
	}
	cacheTime=cacheTime||86400*365*100;
	if(typeof APP_TAG!='undefined'){
		objName=APP_TAG+objName;
	}
	
	var LS_objValue=clone(objValue);
	var a=_objName.match(/^[A-Z]/);
	if(a!=null && _cacheTime!=-1){
		LS.set(_objName,LS_objValue);
	}

	if(typeof objValue!='object'){
		objValue={ddObjValue:objValue};
	}
	objValue.ddEndCacheTime=cacheTime+time();
	objValueStr=JSON.stringify(objValue);
	window.localStorage.setItem(objName,objValueStr);
	delete objValue.ddEndCacheTime;  //js的函数如果参数是对象，就会是一个引用
}

/*
获取数据
objName：名称
unset：获取后是否直接删除，1删除，0不删
*/
function get(objName,unset){
	if(typeof APP_TAG!='undefined'){
		objName=APP_TAG+objName;
	}
	unset=unset||0;
	var result = '';
	result=window.localStorage.getItem(objName);
	if(typeof result=='undefined' || result=='undefined' || result==null){
		return '';
	}

	result=JSON.parse(result);
	if(typeof result.ddObjValue!='undefined'){
		var r=result.ddObjValue;
	}
	else{
		var r=result;
	}
	if(typeof result.ddEndCacheTime!='undefined' && result.ddEndCacheTime<=time()){
		unset=1;
	}
	if(unset==1){
		window.localStorage.removeItem(objName);
	}
	if(typeof r.ddEndCacheTime!='undefined'){
		delete r.ddEndCacheTime;
	}
	return r;
}

/*
删除本地存储
objName：名字
*/
function unset(objName){
	objName=objName||'';
	var storage = window.localStorage;
	if(objName==''){
		storage.clear();
	}
	else{
		var a=objName.match(/^[A-Z]/);
		if(a!=null){
			LS.unset(objName);
		}
		
		if(typeof APP_TAG!='undefined'){
			objName=APP_TAG+objName;
		}
		storage.removeItem(objName);
	}
}

/*
状态存储
*/
function logStatus(name,val){
	name='s_'+name;
	var storage = window.localStorage;
	if(typeof val=='undefined'){
		if(typeof storage[name]=='undefined'){
			var show=1;
		}
		else{
			if(storage[name]==1){
				var show=0;
			}
			else if(storage[name]==0){
				var show=1;
			}
		}
		storage[name]=show;
		return show;
	}
	else{
		storage[name]=val;
	}
}

function clearLogStatus(){
	var storage = window.localStorage;
	for(var i in storage){
		if(i.match(/^s_/i)){
			storage.removeItem(i);
		}
	}
}

/*
console.log函数简写
*/
function log(str){  //log是js的系统函数，返回一个数字的对数（没什么用，就重新定义了）
	console.log(str);
}

/*
对转转网址参数
*/
function ddSerialize(obj){
	var s='';
	for(var i in obj){
		s+='&'+i+'='+urlencode(obj[i]);
	}
	return s;
}

/*
网址和对象拼接
p：可以是对象，也可以是参数链
*/
function ddJoin(url,p){
	p=p||'';
	if(appcan.isPlainObject(p) || appcan.isArray(p)){
		p=ddSerialize(p);
	}
	if(url.indexOf('?')<0){
		p='?'+p;
	}
	url+=p;
	return url;
}

/*获取模板函数*/
function getTpl(_function){
	var tpl=_function.toString();
	tpl=tpl.replace(/function\s*\w+\s*\(\)\s*{\/\*/,'').replace(/\*\/;}$/,'');
	return tpl;
	//alert(tpl.match(/^[\w]+\snav_tpl\(\)\{\s+\/\*([\w\s*\/\\<>'"=#;:$.()]+)\*\/\s+\}$/i)[1]);
}

function getFuncName(_callee) {
	var ie = !-[1,];
	if(ie==true){
		var _text = _callee.toString();
		return _text.match(/^function\s*(\w+)\s*\(/)[1];
	}
	else{
		return _callee.prototype.constructor.name;
	}
}

/*
整数格式化
*/
function ddInt(s){
	if(s==null || s=='null' || s=='' || isNaN(s)){
		return 0;
	}
	else{
		return parseInt(s,10);
	}
}

/*
浮点数格式化
*/
function ddFloat(s){
	if(s==null || s=='null' || s==''){
		return 0;
	}
	else{
		return parseFloat(s,10);
	}
}

/*
是否存在数组（对象）中
*/
function inArray(arr,v){
	var l=arr.length;
	for(i=0;i<l;i++){  
		if(arr[i] == v)  return true;  
	}  
	return false;  
}

/*
去空函数
*/
/*String.prototype.trim=function(){
	return this.replace(/(^\s*)|(\s*$)/g, "");
}
String.prototype.ltrim=function(){
　　return this.replace(/(^\s*)/g,"");
}
String.prototype.rtrim=function(){
	return this.replace(/(\s*$)/g,"");
}*/

/*
验证表单函数
*/
function checkForm($this,cb){
	var $input={};	
	var word='';
	var status=true;
	var ddPatternArr={'email':/^[-_A-Za-z0-9\.]+@([_A-Za-z0-9]+\.)+[A-Za-z0-9]{2,3}$/,'int':/^[0-9]+$/,'num':/^[0-9]+(.[0-9]{2})?$/,'float':/^[0-9]+\.?[0-9]+$/,'mobile':/^1\d{10}$/,'alipay':'email|mobile'};
	var input={};
	var $form=$this;
	
	function tip(word2){
		if(word!=''){
			toastOpen(word);
		}
		else{
			toastOpen(word2);
		}
		$input[0].focus();
		status=false;
		return false;
	}
	
	function getAttr(name){
		return $input.attr(name);
	}
	
	$this.find('input,select').each(function(){
		if(status==false){ //return false不能退出循环，所以增加了这个判断（可能是jqmobi不行吧，jquery没测试）
			return false;
		}
		
		$input=$(this);
		
		if(getAttr('type')=='submit'){
			return false;
		}
		
		word=getAttr('word');
		if(word==null){
			word='';
		}
		var str=$(this).val();
		if(getAttr('dd-required')!=null && str==''){
			return tip('此项必填');
			return false;
		}
		
		if(getAttr('dd-equal')!=null){
			if(str!=$('#'+getAttr('dd-equal')).val()){
				return tip('与要求项不相符');
			}
		}

		if(getAttr('dd-max')!=null && str!=''){
			var ddMax=parseFloat($(this).attr('dd-max'));
			str=parseFloat(str);
			if(str>ddMax){
				return tip('数值错误');
			}
		}
		
		if(getAttr('dd-min')!=null && str!=''){
			var ddMin=parseFloat(getAttr('dd-min'));
			str=parseFloat(str);
			if(str<ddMin){
				return tip('数值错误');
			}
		}
		
		if(getAttr('dd-maxl')!=null && str!=''){
			var ddMaxl=getAttr('dd-maxl');
			var l=str.length;
			if(l>ddMaxl){
				return tip('长度错误');
			}
		}
		
		if(getAttr('dd-minl')!=null && str!=''){
			var ddMinl=getAttr('dd-minl');
			var l=str.length;
			if(l<ddMinl){
				return tip('长度错误');
			}
		}
		var ddType=getAttr('dd-type');
		if(ddType!='' && ddType!=null && str!=''){
			if(typeof ddPatternArr[ddType]!='undefined'){
				if(typeof ddPatternArr[ddType]=='string'){
					var regArr=ddPatternArr[ddType].split('|');
					var l=regArr.length;
					var i=0;
					for(var i=0;i<l;i++){
						if(ddPatternArr[regArr[i]].test(str)==true){
							i++;
						}
					}
					if(i==0){
						return tip('此项格式错误');
					}
				}
				else if(ddPatternArr[ddType].test(str)==false){
					return tip('此项格式错误');
				}
				
			}
		}
		if(getAttr('dd-pattern')!=null && getAttr('dd-pattern')!='' && str!=''){
			var reg = eval($(this).attr('dd-pattern'));
			if(reg.test(str)==false){
				return tip('此项格式错误');
			}
		}
		
		var name=getAttr('name');
		input[name]=str;
	});
	if(status==true){
		cb($form,input);
	}
	return false;
}

/*
encodeURIComponent函数简写
*/
function urlencode(str){
	return encodeURIComponent(str);
}

/*
是否为空
*/
function notNUll(o){
	if(typeof o!='undefined' && o!='' && o!='null' && o!=null){
		return 1;
	}
	else{
		return 0;
	}
}

/*
单个img的lazy加载
*/
function imagesLoad(jq_t){
	var t=jq_t[0];
	function imagesLad_setImg(jq_t,data){
		var t=jq_t[0];
		if (typeof t.tagName!='undefined' && t.tagName.toLowerCase() == 'img') {
			jq_t.attr('src', data);
		} else {
			t.style.backgroundImage = "url(" + data + ")";
		}
		t.setAttribute('onloadover',1);
		jq_t.removeClass('lazyimg');
	}
	
	var url=t.getAttribute('data-img');
	if(t.getAttribute('onloadover')==1){
		return false;
	}
	var img=new Image();
    img.src=url;
	if (img.complete) {
		imagesLad_setImg(jq_t,url);
	} else {
		img.onload = function () {
			t.setAttribute('src',url);
			img.onload = null;
			imagesLad_setImg(jq_t,url);
		}
	}
}

/*
noDownImg：默认下载图片，1为不下载图片
使用方法步骤说明：
1，该方法可适用于div的backgroundImage或者img，图片开始要设置为等待加载的图片
2，给元素增加lazyimg类
3，实际的图片保存在该元素的data-img属性中
*/
function loadLazyImg(noDownImg){
	noDownImg=noDownImg||0;
	function doImg(jq_t,data){
		if (typeof jq_t[0].tagName!='undefined' && jq_t[0].tagName.toLowerCase() == 'img') {
			jq_t.attr('src', data);
		} else {
			jq_t[0].style.backgroundImage = "url(" + data + ")";
		}
		jq_t.removeClass('lazyimg');
	}

	var imgId='';
	var dataSrc='';
	var status=0;
	jq('.lazyimg').each(function(){
		var jq_t=jq(this);
		imagesLoad(jq_t);
		/*status=ddInt(jq_t.attr('status'));
		if(status==0){
			dataSrc=jq_t.attr('data-img');
			if(noDownImg==1){
				doImg(jq_t,dataSrc);
			}
			else{
				downLoad(dataSrc,function(data){//alert(jq_t.attr('imgId'));
					doImg(jq_t,data);
				});
			}
		}
		else{
			jq_t.attr('status',1);
		}*/
	});
}

/*
获取页面信息
contentId：主体元素id
headerId：头部元素id
footerId：底部元素id
结果集
fontSize：字体大小
headH：头部高度
footH：底部高度
contentH：主体宽度
contentW：主体宽度
pageH：主体+底部高度
*/
function pageParameIni(contentId,headerId,footerId){
	var pageParame={'a':1};
	contentId=contentId||'content';
	headerId=headerId||'header';
	footerId=footerId||'footer';
	if(typeof jq('#'+contentId)[0]=='undefined'){
		contentId='mainhtml';
	}
	var a=window.getComputedStyle(jq('#'+contentId)[0],null);
	pageParame.fontSize=ddInt(a.fontSize.replace(/px/i,''));
	if(jq('#'+headerId).length>0){
		pageParame.headH=ddInt(jq('#'+headerId)[0].offsetHeight);
	}
	
	if(typeof jq('#'+footerId)[0]!='undefined'){
		pageParame.footH=ddInt(jq('#'+footerId)[0].offsetHeight);
	}
	else{
		pageParame.footH=0;
	}
	pageParame.contentH=ddInt(a.height.replace(/px/i,''));
	pageParame.contentW=ddInt(a.width.replace(/px/i,''));
	pageParame.windowW=pageParame.contentW;
	pageParame.windowH=ddInt($(window).height());
	pageParame.pageH=pageParame.windowH-pageParame.headH;
	var android = window.navigator.userAgent.indexOf('Android');
    if (android < 0) {
    	pageParame.screenBodyBi = 1;
    }
	else{
		pageParame.screenBodyBi = parseInt(parseInt(window.screen.width)) / parseInt($('body').width(), 10);
	}
	set('pageParame',pageParame);
	return pageParame;
}

/*
url：要下载的网址
callback：下载后的回调函数
ignoreLocal：是否忽略本地，0不忽略，1忽略
jindu：是否显示进度，toast模式
*/
function downLoad(url,callback,ignoreLocal,jindu,pathName){
	pathName=pathName||'';
	if(get('plat_form')==-1 || url.indexOf('http')!=0){
		callback(url);
		return false;
	}
	
	function doCallBack(opCode){
		var backFile='file://'+get('ddroot')+savePathObj[opCode]['path'].replace('wgt://','');
		savePathObj[opCode]['fun'](backFile);
		savePathObj[opCode]['ok']=1;
		delete savePathObj[opCode];
		for(var i in tmpOp){
			if(tmpOp[i]==opCode){
				doCallBack(i);
			}	
		}
	}
	function fileExists(opCode){
		appcan.file.exists({
			optId:opCode,
			filePath:savePathObj[opCode]['path'],
			callback:function(err,data,dataType,optId){  /*注意，这个进程号在模拟器下无效*/
				if(err){/*判断文件文件出错了*/
					return;
				}
				if(data == 1){/*文件存在*/
					doCallBack(optId);
					return true;
				}else{
					uexDownloaderMgr.createDownloader(optId);
				}
			}
		});
	}

	ignoreLocal=ignoreLocal||0;
	jindu=jindu||0;
	var inOpCode=getPID();
	var inOpCodeStr=String(crc32(url));
	var ext=url.match(/\.\w+$/);

	if(typeof window.savePathObj=='undefined'){
		window.savePathObj={};
		window.tmpOp={};
	}
	savePathObj[inOpCode]={};
	var suiji=inOpCodeStr.substr(0,2)+'/'+inOpCodeStr;
	savePathObj[inOpCode]['fun']=callback;
	if(pathName==''){
		pathName="wgt://data/down/"+suiji+ext;
	}
	savePathObj[inOpCode]['path']=pathName;
	for(var i in savePathObj){
		if(url==savePathObj[i]['url']){
			tmpOp[inOpCode]=i;  /*当前进程号和同url进程号的对应*/
			if(typeof savePathObj[i]['ok']!='undefined' && savePathObj[i]['ok']==1){
				doCallBack(inOpCode);
			}
			else{
				savePathObj[inOpCode]['url']=url;
				return true;
			}
		}
	}

	savePathObj[inOpCode]['url']=url;

	if(ignoreLocal==0){  /*是否判断本地有就不下载了*/
		fileExists(inOpCode);
	}
	else{
		uexDownloaderMgr.createDownloader(inOpCode);
	}
	
	uexDownloaderMgr.onStatus = function(opCode,fileSize,percent,status){
		switch (status) {
			case 0:
				if(jindu==1){
					var str = '下载进度：'+percent+'%';
			  		if(fileSize==-1) str = '下载中，请稍候...';
			  		uexWindow.toast('1','5', str,'');
				}
			break;
			case 1:
				uexDownloaderMgr.closeDownloader(opCode);
				if(jindu==1){
					uexWindow.closeToast();
				}
				doCallBack(opCode);
			break;
			case 2:
				if(jindu==1){
					uexWindow.toast('0','5','下载失败','2000');
				}
				uexDownloaderMgr.closeDownloader(opCode);
				doCallBack(opCode);
			break;
		}
	};
		
	uexDownloaderMgr.cbCreateDownloader = function(opCode,dataType,data){
		if(data == 0){
			uexDownloaderMgr.download(opCode,savePathObj[opCode]['url'],savePathObj[opCode]['path'],'0');
		}
		else{
			if(jindu==1){
				uexWindow.toast('0','5','创建下载失败','2000');
			}
		}
	};
}

/*
计数器，最大值65536
*/
var getPID = function(){
	var maxId = 65536;
	var uid = 0;
	return function(){
		uid = (uid+1)%maxId;
		return uid;
	};
}();

/*
获取环境信息
plat_form：平台信息，-1模拟器，0苹果，1安卓
app_version：版本
app_id：appid
*/
function checkDevelop(callback){ //判断是否是真机调试环境
	uexDevice.cbGetInfo=function (opCode,dataType,data){
        var device = JSON.parse(data);
		if(typeof device.os!='undefined'){
			set('app_os',device.os);
		}
		else if(typeof device.manufacturer!='undefined'){
			set('app_mfr',device.manufacturer);
		}
		else if(typeof device.imei!='undefined'){
			set('app_imei',device.imei);
		}
    };
	uexDevice.getInfo(1);
	uexDevice.getInfo(2);
	uexDevice.getInfo(10);

	callback=callback||'';
	if (MONIQI==0) {
		var sUserAgent = navigator.userAgent.toLowerCase();
		var isIphone = sUserAgent.match(/iphone/i) == "iphone";
		var isAndroid = sUserAgent.match(/android/i) == "android";
		if(isIphone){
			set('plat_form',0); 
		}
		if(isAndroid){ 
			set('plat_form',1); 
		}
	}
	else{
		set('plat_form',-1);
	}
	uexWidgetOne.getCurrentWidgetInfo();
	
	uexWidgetOne.cbGetCurrentWidgetInfo = function(opId,dataType,data){
		if(dataType==1){
			var data =JSON.parse(data);
			set('app_version',data.version);
			set('app_id',data.appId);
			
			appcan.file.getRealPath("wgt://",function(err,data,dataType,optId){
				if (MONIQI==0) {
					
				}
				else{ //如果是模拟器
					data='file:///'+data;
				}
				set('ddroot',data);
				callback();
			})
		}
	};
}

/*
是否是网址
*/
function isUrl(str){ 
    str = str.match(/http[s]?:\/\/.+/); 
    if (str == null){ 
        return 0; 
    }else{ 
        return 1; 
    } 
}

/*
如果body有类pageshow a-op，默认不显示，执行pageShow有渐变显示的特效
*/
function pageShow(css){
	$('head').append('<style>'+css+'</style>');
}

/*
name：窗口名称，每一个窗口必须有一个唯一的名称
url：窗口url，如果为空，url为name.html
aniId：动画效果，默认是从右到左切入，详见appcan文档
type：窗口类型，详见appcan文档
*/
function openWin(name,url,aniId,type){
	if(name=='page_x'){
		var _name='page_'+get('ddmod');
	}
	else{
		var _name=name;
	}
	if(aniId==0){
		aniId=0;
	}
	else{
		aniId=aniId||10;
	}
	type=type||0;
	url=url||'';
	if(url==''){
		var url=name+".html";
	}
	if(get('plat_form')>=0){type+=2;}
	appcan.window.open(_name, url, aniId, type);
}

/*
name：浮动层名臣，每一个浮动层必须有一个唯一的名称
url：浮动层网址，如果为空，url为name.html
type：浮动层的类型，默认是html类型，url为网址类型，catch也是网址类型，附带获取网址的特效
id：把id元素的宽高指定为浮动窗口的宽高，把id元素的font-size设置为id元素的font-size
touming：浮动层是否透明，1是透明，2是不透明
*/
function openFrame(name,url,type,id,touming){
	type=type||'';
	url=url||'';
	id=id||'content';
	touming=touming||1;
	if(typeof pageParame=='undefined'){
		pageParame=get('pageParame');
	}
	if(isUrl(url)){
		if(type=='catch'){
			var flag=513;
		}
		else{
			var flag=512;
		}
		if(touming==2){
			flag=flag+16;
		}
		if(get('plat_form')>=0){flag+=2;}
		appcan.frame.open(id, url, 0, pageParame.headH,name,0,function(){},flag);
	}
	else{
		if(name.indexOf('.html')<0){
			var url=name+".html";
		}
		else{
			var url=name;
		}
		var flag=0;
		if(JIAMI==1){flag+=2;}
		appcan.frame.open(id, url, 0, pageParame.headH,name,0,function(){},flag);
	}
}

function checkAuth(time,alt){
	/*time=time||86400;
	alt=alt||0;
	var url='http://yun.duoduo123.com/index.php?m=Api&a=one&code=phone_app&url='+urlencode(WEBURL);

	var obj={
		url:url,
		cacheTime:time,
		success:function(data){
			if(data.s==1){
				if(alt==1){
					jq('#content').html('授权获取成功，请重启app。<span onclick="uexWidgetOne.exit(0);">退出app</span>');
				}
			}
			else{
				var webset=get('webset');
				var s='<div style=" margin:auto; width:90%;"><span style=" font-size:1em">此应用已经过期，请联系网站管理员QQ:'+webset['qq']+'</span><br/><br/><input onclick="checkAuth(0,1)" class="dd-btn  ulev0  uc-a us btn" id="sub" type="submit" value="更新" /></div>';
				jq('#header').css('visibility','hidden');
				jq('#footer').css('visibility','hidden');
				jq('#content').html(s);
				popoverScript("appcan.frame.close('index')",'index','page_root');
				toastOpen('授权到期');
			}
		}
	};
	ddRequest(obj);*/
}

function getDdUrl(){
	var canshu=['DD_PASSWORD','DD_UID','DD_areaId'];
	var str='';
	for(var i in canshu){
		str+=canshu[i]+'='+urlencode(get(canshu[i]))+'&';	
	}
	return WEBURL+str;
}

function getFlUrl(){
	var canshu=['DD_PASSWORD','DD_UID'];
	var str='';
	for(var i in canshu){
		str+=canshu[i]+'='+urlencode(get(canshu[i]))+'&';	
	}
	return FANLIURL+str;
}

function getCfUrl(){
	var str='';
	str+='duxiangurl='+urlencode('http://www.lalashequ.cn')+'&';   
	return CFURL+str;
}

function getddApiUrl(arr){
	p=ddSerialize(arr);
	var url=get('DD_APIURL')+p+'&uid='+get('DD_UID')+'&ddpassword='+get('DD_PASSWORD')+'&';
	return url;
}
/*
pageShow：给body去掉隐藏，body如果有class“pageshow a-op”，默认显示，pageShow执行后会有个渐变显示的效果
pageParame：页面信息（高度宽度等）
*/

function ddOnLoad(fun,delay){
	if(WIN_NAME=='root' || (WIN_NAME.indexOf('page_')==0 && WIN_NAME!='page_root')){
		var p=window.pageParame=pageParameIni();
		if(WIN_NAME=='root'){
			set('pageRootP',p);
		}
	}
	if(WIN_NAME=='root'){
		checkIos7();
		if(MONIQI==0){
			LS.get('aa',function(data){
				for(var i in data){
					if(get(data[i]['k'])==''){
						if(data[i]['v'].indexOf('##')>=0){
							data[i]['v']=data[i]['v'].replace(/##/g,'"');
							data[i]['v']=JSON.parse(data[i]['v']);
						}
						set(data[i]['k'],data[i]['v'],-1);
					}
				}
				checkDevelop(fun);
			});
		}
		else{
			checkDevelop(fun);
		}
	}
	else{
		if(typeof window.pageInfo=='undefined'){
			window.pageInfo=get('pageInfo');
		}
		APIURL=getDdUrl();
		DD_APIURL=getddApiUrl();
		if(WIN_NAME.indexOf('page_')==0){ //是window窗口
			appcan.button(".nav-btn", "btn-act",function() {
				if(this.id=='nav-left'){
					leftBtn();
				}
				else{
					rightBtn();
				}
			});
			if(WIN_NAME!='page_root'){ //page_root窗口有接收订阅，不能再有第二个，模拟器下错误
				subscribe(pageInfo.fatherName, function(data) {
					alert(data);
				});
			}
		}
		else{ //是浮动窗口
			window.fatherLeftBtn=function(){
				wescript('','leftBtn()');
			}
			window.fatherSetTitle=function(title){
				wescript('','setTitle("'+title+'")');
			}
			window.fatherSetRightBtn=function(html){  //注意，html不能有引号
				wescript('','rightBtnHtml("'+html+'")');
			}
			subscribe(pageInfo.fatherName+'_'+pageInfo.name, function(data) {
				rightBtn();
			});
			
			window.pageParame=get('pageParame');
		}
		
		function ddOnLoad_2(){
			if(typeof get('ddroot')=='undefined' || get('ddroot')==''){
				appcan.file.getRealPath("wgt://",function(err,data,dataType,optId){
					set('ddroot',data);
					downLoad_3();
				})
			}
			else{
				downLoad_3();
			}
		}
		
		function downLoad_3(){
			pageShow(TEMPLATE['css']);
			fun();
			if(WIN_NAME=='page_root'){
				//listenReturnRoot();
			}
			else{
				listenReturn();
			}
		}
		
		TEMPLATE=get('template');
		if(ACT=='x'){
			if(MOD!='page'){
				MOD=get('ddmod');
			}
			ACT=get('ddact');
		}
		if(get('debug')==1){
			var pageParame=get('pageParame');
			var url=WEBURL+'mod_tpl=1&mod='+MOD+'&act='+ACT+'&DD_UID='+get('DD_UID')+'&area_id='+get('DD_areaId')+'&pageParame='+urlencode(JSON.stringify(pageParame));
			var obj={
				url:url,
				dataType:'text',
				cacheTime:0,
				tip:'模板加载中',
				success:function(tpl){
					TEMPLATE[MOD+'_'+ACT]=tpl;
					ddOnLoad_2();
				}
			};
			ddRequest(obj);
		}
		else{
			ddOnLoad_2();
		}
	}
}

/*
检测版本并提示升级
*/
function checkUpdateBanben(upTip){
	upTip=upTip||0;
	var appInfo=get('appinfo');
    var iosUpdateUrl=appInfo.ios_update_url;
    var androidUpdateUrl=appInfo.android_update_url;
	var iosBanben=appInfo.ios_banben;
	var androidBanben=appInfo.android_banben;
	var iosUpdateMsg=appInfo.ios_update_content;
	var androidUpdateMsg=appInfo.android_update_content;
	
	function shengji(data){
        if(data==1){
            if(get('plat_form')==0){
                uexWidget.loadApp(iosUpdateUrl,null,null);
            }
            else if(get('plat_form')==1){
				downLoad(androidUpdateUrl,function(data){
					uexWidget.installApp(data);
				},1,1);
            }
            else{
                alert('模拟器测试');
            }
        }
    }
    var APP_VERSION=get('app_version');
    var banben='',updateMsg='';
    if(get('plat_form')==0){
        banben=iosBanben;
        updateMsg=iosUpdateMsg;
    }
    else if(get('plat_form')==1){
        banben=androidBanben;
        updateMsg=androidUpdateMsg;
    }
	else{
		/*banben=androidBanben;
        updateMsg=androidUpdateMsg;*/
	}
	banben=ddInt(banben.replace(/00\.00\./,''));
	APP_VERSION=ddInt(APP_VERSION.replace(/00\.00\./,''));
    if(banben>APP_VERSION){
        openConfirm("当前有新版本，是否更新？",updateMsg,['稍后更新','马上更新'],shengji);
    }
	else if(upTip==1){
		toastOpen('已经是最新版本');
	}
}

/*
检测模板
*/
function checkUpdateTpl(fun){
	if(typeof fun!='function'){
		fun=start_2;
	}
	if(typeof pageParame=='undefined'){
		var pageParame=get('pageParame');
	}
	
	var downloadpath = getDdUrl()+'mod=set&act=tpl&pageParame='+urlencode(JSON.stringify(pageParame))+'&banben=1&app_ios7='+ddInt(get('ios7'));
	var canshu_arr=['plat_form','app_version','app_id','app_os','app_mfr','app_imei'];
	for(var i in canshu_arr){
		downloadpath+='&'+canshu_arr[i]+'='+urlencode(get(canshu_arr[i]));
	}
	
	toastOpen('主题初始化',-1);
	window.savePathObj={};
	window.tmpOp={};
	downLoad(downloadpath,function(path){
		function checkUpdateTpl_over(tpldata){
			TEMPLATE=JSON.parse(tpldata);
			banben=TEMPLATE['banben'];
			set('DD_TPLBANBEN',banben);
			set('template',TEMPLATE);
			toastClose();
			if(typeof fun=='function'){
				fun();
			}
		}
		
		function checkUpdateTpl_urlget(){
			var obj={
				url:downloadpath,
				dataType:'text',
				cacheTime:0,
				success:function(tpldata){
					if(tpldata!=''){
						checkUpdateTpl_over(tpldata);
					}
					else{
						openAlert('主题初始化远程获取失败');
					}
				}
			};
			ddRequest(obj);
		}
		if(MONIQI==1){
			checkUpdateTpl_urlget();
		}
		else{
			var suiji=Math.round(Math.random()*100000)+112233;
			uexFileMgr.openFile(suiji,TPL_PATH,1);
			uexFileMgr.cbOpenFile=function(opId,dataType,data){
				if(data == 0){
					uexFileMgr.cbReadFile = function(opId, dataType, tpldata) {
						uexFileMgr.closeFile(opId);
						if(typeof tpldata=='undefined' || tpldata=='undefined' || tpldata=='' || tpldata=='(null)'){
							openAlert('主题初始化获取失败');
							checkUpdateTpl_urlget();
						}
						else{
							checkUpdateTpl_over(tpldata);
						}
					};
					uexFileMgr.readFile(opId, -1);
				}else{
					uexFileMgr.closeFile(opId);
					openAlert('主题初始化本地获取失败');
					checkUpdateTpl_urlget();
				}
			};
		}
	},1,0,TPL_PATH);
}

/*
用插件打开网址，可带有拦截和执行js的功能
*/
function openMJUrl(url,type,cb){
	if(MONIQI==0){
		if(type==1){  //淘宝列表，设置拦截网址
			uexMJWebBrowser.cbOpen = function(opCode, dataType, data){
				cb(data);
			};
			uexMJWebBrowser.intercept('http://mclick.simba.taobao.com','http://s.click.taobao.com','https://mclick.simba.taobao.com','https://s.click.taobao.com');
		}
		else if(type==2){  //淘宝详情页，设置执行的js
			var jscode="var DD_REMOVE_TIP=0;function removeAppTip() {DD_REMOVE_TIP++;if(DD_REMOVE_TIP>=50){clearTimeout(removeAppTipPid);return false;}var a = document.getElementsByClassName('c-fs-loading');a = a[0];a = a.nextSibling;ddremove(a);}function ddremove(a) {if (typeof a.className != 'undefined' && a.className != '' && a.className.indexOf('dsk')>=0) {var _parentElement = a.parentNode;if (_parentElement) {_parentElement.removeChild(a);document.body.style.paddingTop=0;clearTimeout(removeAppTipPid);}} else {a = a.nextSibling;if (a) {ddremove(a);}}}var removeAppTipPid = setInterval(removeAppTip, 100);";
			if(get('plat_form')==0){
				uexMJWebBrowser.execJs(jscode,'100');
			}
			else{
				uexMJWebBrowser.execJs('cc',jscode,'100');
			}
		}
		else if(type==3){  //京东详情页，设置执行的js
			var jscode="var DD_REMOVE_TIP=0;function getElementsClass(classnames){var classobj= new Array(); var classint=0; var tags=document.getElementsByTagName('*'); for(var i in tags){ if(tags[i].nodeType==1 && !isNaN(i)){ var a=tags[i].getAttribute('class');if(typeof a!='undefined' && a!='' && a!=null && a.indexOf(classnames)>=0){classobj[classint]=tags[i]; classint++;}}}if(typeof classobj[1]=='undefined'){return classobj[0];}else{return classobj;}}function removeAppTip(){DD_REMOVE_TIP++;if(DD_REMOVE_TIP>=50){clearTimeout(removeAppTipPid);return false;}var a=getElementsClass('tryme');a.style.display='none';clearTimeout(removeAppTipPid);}var removeAppTipPid = setInterval(removeAppTip, 100);";
			if(get('plat_form')==0){
				uexMJWebBrowser.execJs(jscode,'100');
			}
			else{
				uexMJWebBrowser.execJs('cc',jscode,'100');
			}
		}
		uexMJWebBrowser.open(url,'0',pageParame.headH,pageParame.contentW,pageParame.pageH);	
	}
	else{
		openFrame('uexMJ',url,'catch');
	}
}

function openUrl(name,url,title){
	set('ddact',name);
	var pageInfo={'url':url,'title':title};
	set('pageInfo',pageInfo);
	openWin('page_x');
}

/*
用来打开新页面
name：窗口和浮动层名称
url：浮动层网址，如果为空，默认name.html
type是页面类型，默认是html（本地页面），url（网址），catch（网址，带有抓取网址的功能）
*/
function openPage(name,url,type,title){
	if(name=='x_x'){
		if(typeof url!='undefined'){
			set('ddmod',url);
			set('ddact',type);
		}
		var _name=get('ddmod')+'_'+get('ddact');
	}
	else{
		var _name=name;
	}
	type=type||'html';
	url=url||'';
	title=title||'';
	if(url==''){
		url=name+'.html';
	}
	var winName='page_'+_name;
	var pageInfo={'name':name,'url':url,'fatherName':winName,'type':type,'title':title};
	set('pageInfo',pageInfo);
	openWin(winName,'page_html.html',10,0);
}

function writeJs(js){
	document.write("<script src='"+js+"'></script>");
}

/*
应用在提交表单中，在提交之前使用start，在结束回调使用end
表单中需要存在按钮class为submit，也可以为任意的div
函数有点击后样式变化和提交中避免重复点击的效果
*/
var doSubmit={
	'start':function(t){
		var subTime=ddInt(t.data('subTime'));
		if(subTime>0){
			//log('start_error');return;
		}
		else{
			t.data('subTime',time());
		}
		t.find(".submit .fa").removeClass('fa-check');
		t.find(".submit .fa").addClass('fa-spinner fa-spin');
		this.word=t.find(".submit .text").text();
		t.find(".submit .text").text(this.word+'中……');
		this.pid=setTimeout(function(){doSubmit.end(t)},this.waitTime);
	},
	'end':function(t){
		var subTime=ddInt(t.data('subTime'));
		
		if(subTime>0){
			t.data('subTime',0);
		}
		else{
			//log('end_error');return;
		}
		t.find(".submit .fa").removeClass('fa-spinner fa-spin');
		t.find(".submit .fa").addClass('fa-check');
		t.find(".submit .text").text(this.word);
		clearInterval(this.pid);
	},
	'waitTime':5000,
	'pid':'',
	'word':'',
}

/*
网络请求函数，可异步同时提交
type：请求类型，GET或者POST
dataType：请求内容，json或者html
timeout：请求超时时间
cacheTime：缓存时间
data：网址参数，如果是提交文件，参数为data:{file:{path:'a.jpeg'}}
*/
function ddRequest(obj){
	obj.tip=obj.tip||'';
	obj.type=obj.type||'GET';
	obj.dataType=obj.dataType||'json';
	obj.timeout=obj.timeout||30000;
	obj.cacheTime=obj.cacheTime||0;
	obj.data=obj.data||{};
	var md5Name=appcan.crypto.md5(obj.url).toLowerCase();
	obj.data.plat_form=get('plat_form');
	obj.data.app_version=get('app_version');
	obj.data.app_id=get('app_id');
	obj.data.app_os=get('app_os');
	obj.data.app_mfr=get('app_mfr');
	obj.data.app_imei=get('app_imei');
	obj.data.app_ios7=ddInt(get('ios7'));
	var urlLog={'url':obj.url,'a':1};
	log(urlLog);
	//$('#aaa').val(obj.url);
	
	
	if(obj.cacheTime>0){
		var v=get(md5Name);
		if(v!=''){
			obj.success(v);
			return true;
		}
	}
	else{
		unset(md5Name);
	}
	if(obj.tip!=''){
		toastOpen(obj.tip,-1);
	}
	appcan.request.ajax({
		type: obj.type,
	  	url: obj.url,
	  	data: obj.data,
	  	timeout: obj.timeout,
		dataType:obj.dataType,
	  	success: function(data){
			if(obj.tip!=''){
				toastClose();
			}
			if(obj.cacheTime>0){
				set(md5Name,data,obj.cacheTime);
			}
		  	obj.success(data);
	  	},
	  	error: function(xhr, type){
			toastClose();
			alert('网络连接失败，请从新尝试');
	  	}
	})
}


/*
下拉刷新当前页
*/

function reLoad(){
	/*for(var i in tplHtml){
		$('#'+tplHtml[i]).html('');
	}*/
	start();
}

/*
获取会员信息
attr：如果为空，获取整个user对象信息，如果有值，获取该值信息，是字符串
*/
function getUser(attr){
	attr=attr||'';
	var re;
	var user=get('ddUser');
	if(user==''){user={};}
	if(attr!=''){
		if(attr=='id' || attr=='level'){
			re=ddInt(user[attr]);
		}
		else{
			re=user[attr];
		}
	}
	else{
		re=user;
	}
	return re;
}

/*
判断登陆
winName：来源窗口名，用于登陆成功后
*/
function checkLogin(winName,word){
	word=word||'亲，先登录';
	winName=winName||'';
	var uid=getUser('id');
	if(uid==0){
		toastOpen(word,1000);
		set('referer',winName);
		setTimeout(function(){openPage('login');},1);
		return 0;
	}
	else{
		return 1;
	}
}

/*
uexWindow.alert简写
*/
function openAlert(msg,title,button){
	title=title||'提醒';
	button=button||'好';
	uexWindow.alert(title,msg,button);
}

/*
uexWindow.toast简写
*/
function toastOpen(inMsg,inDuration){
	if(typeof inDuration=='undefined' || inDuration==0){ //2秒后自动关闭，无进度条
		inDuration=2000;
		inType=0;
	}
	else{ //无限时间，带进度条
		inType=1;
	}
	TOAST=1;
	uexWindow.toast(inType,5,inMsg,inDuration);
}

function toastClose(){
	uexWindow.closeToast();
	TOAST=0;
}

function openConfirm(title,msg,button,cb){
	msg=msg||'';
	uexWindow.confirm(title, msg, [button[0],button[1]]);
	
	uexWindow.cbConfirm = function(opId, dataType, data){
		cb(data);
	}
}
		
	
	



/*
订阅渠道
*/
function subscribe(name,callback){
	appcan.window.subscribe(name,function(data){
		callback(data);
	})
}

/*
推送渠道
*/
function publish(name,data){
	appcan.window.publish(name, data);
}

/*
弹动函数
topFun：下拉函数，0为没有下拉
bottomFun：上拉函数，0为没有上拉
appcan的上拉有bug，如果页面的高度小于屏幕高度，上拉不显示图标，这里做了特殊处理，检测如果小于，给body一个大于屏幕的高度
*/
function setBounce(topFun,bottomFun,bgColor,timeWait){
	bgColor=bgColor||'#FFFFFF';
	timeWait=timeWait||2000;
	if(typeof topFun!='function'){
		var haveTopFun=0;
	}
	else{
		var haveTopFun=1;
	}
	
	if(typeof bottomFun!='function'){
		var haveBottomFun=0;
	}
	else{
		var haveBottomFun=1;
		var jq_body=jq('body');
		var a=Math.max(pageParame.pageH,jq_body[0].offsetHeight)+5+'px';
		jq_body[0].style.height=a;
	}
	
	uexWindow.setBounce("1");
	
	if(haveTopFun==1){
		uexWindow.notifyBounceEvent("0","1");
		uexWindow.showBounceView("0", '#F4F4F4', '1');
	}
	else{
		uexWindow.showBounceView("0", bgColor, '0');
	}
	
	if(haveBottomFun==1){
		uexWindow.notifyBounceEvent("1","1");
		uexWindow.showBounceView("1", '#F4F4F4', '1');
	}
	else{
		uexWindow.showBounceView("1", bgColor, '0');
	}
	
	uexWindow.onBounceStateChange = function (type,status){
		
		var bounceTime=get('bounceTime');
		if(!bounceTime || typeof bounceTime!='object'){
			bounceTime={};
		}
		if(typeof bounceTime[WIN_NAME]=='undefined'){
			var lastTime='好久好久';
		}
		else{
			var lastTime=bounceTime[WIN_NAME];
		}
		
		var json_p = '{"levelText":"上次刷新时间：'+lastTime+'"}';
   		uexWindow.setBounceParams('0',json_p);
		
		if(type==0 && status==2 && haveTopFun==1) {
			setTimeout(function(){uexWindow.resetBounceView("0");},timeWait);
			var myDate = new Date();
			bounceTime[WIN_NAME]=myDate.format();
			set('bounceTime',bounceTime);
			topFun();
		}
		if(type==1 && status==2 && haveBottomFun==1) {
			setTimeout(function(){uexWindow.resetBounceView("1");},timeWait);
			bottomFun();
		}
	}
}

/*
安卓后退键，连续两次退出，一次返回上一页
*/
function listenReturn(){
	//如果是android平台，则监听返回按钮事件
    if(get('plat_form')==1){
		var c1c = 0;
		var exit=0;
    	uexWindow.onKeyPressed=function(keyCode){
       		if(keyCode==0){
				if (c1c > 0) {
					exit=1;
           			uexWidgetOne.exit();
					setTimeout(function(){ exit=0;}, 600);
       			}
    		 	else {
       				//uexWindow.toast(0, 5, '再按一次退出应用', 1000); 
           			c1c=1; 
					setTimeout(function(){ c1c=0;if(WIN_NAME!='root' && exit==0){if(typeof closePage=='function'){closePage();}else{winBack();}} }, 10);
      			}
       			return false;
			}
		}
    }
	uexWindow.setReportKey(0,1);
}

/*
安卓后退键，一次退出，用在page_root
*/
function listenReturnRoot(){
	var c1c = 0;
    uexWindow.setReportKey(0,1);
    uexWindow.onKeyPressed = function(){ 
       	if (c1c > 0) {
       	    uexWidgetOne.exit();
       	}
       	else {
       	    uexWindow.toast(0, 5, '再按一次退出应用', 1000); 
       	    c1c=1; setTimeout(function(){ c1c=0; }, 2000);
       	}
       	return false;
    };
}

/*
控制浮动层触发js
*/
function popoverScript(str,popName,winName){
	uexWindow.evaluatePopoverScript(winName,popName,str);
}

/*
控制窗口触发js
wn为空表示浮动层的父窗口
*/
function wescript(wn, scr){
	wn=wn||pageInfo.fatherName;
	uexWindow.evaluateScript(wn,0,scr);
}

/*
返回上一页，自动判断是否是窗口或者浮动层
*/
function winBack(){
	if(WIN_NAME.indexOf('page_')==0){
		appcan.window.close(-1);
	}
	else{
		wescript('','appcan.window.close(-1)');
	}
}

/*
浮动层控制窗口返回
*/
function setPageBack(tip){
	if(tip!=''){
		toastOpen(tip,3000);
		setTimeout("wescript('','winBack()')",2000);
	}
	else{
		wescript('','winBack()');
	}
}

/*
文件创建写入
*/
function filePutContents(file,content,callback){
	appcan.file.write({
		filePath:file,
		content:content,
		callback:function(err){
			if(err){
				alert(err);
				return;
			}
			else if(callback){
				callback();
			}
		}
	});
}

/*
文件读取
*/
function fileGetContents(file,callback){
	appcan.file.read({
		filePath:file,
		callback:function(err,data,dataType,optId){
			if(MONIQI==1){
				if(!err){
					callback(data);
				}
			}
			else{
				callback(data);
			}
		}
	});
}

/*
上传组件
*/
window.AJAX = {
	callBack : {},cbCall:{},index : 1,
	get : function(url,succCall,errCall,timeout){
		var id = this.index++;
		this.cbCall[id]=[succCall,errCall];
		uexXmlHttpMgr.open(id,'get',url,(timeout||0));
		this._send(id);
	},
	post : function(url,data,succCall,errCall,timeout){
		var id = this.index++;
		this.cbCall[id]=[succCall,errCall];
		uexXmlHttpMgr.open(id,'post',url,(timeout||0));
		if(data){
			for(var k in data){
				if(k=='upload_file'){
					var ft=1;
				}
				else{
					var ft=0;
				}
				if(get('plat_form')==-1){
					data[k]=urlencode(data[k]);
				}
				uexXmlHttpMgr.setPostData(id,ft,k,data[k]);
			}
		}
		this._send(id);
	},
	_send : function(id){
		uexXmlHttpMgr.onData = this.onData;
		uexXmlHttpMgr.send(id);
	},
	onData : function(inOpCode,inStatus,inResult){
		var that=AJAX,callBack = that.cbCall[inOpCode]||[];
		if(inStatus==-1){
			callBack[1] && callBack[1]();
		}else if(inStatus==1){
			callBack[0] && callBack[0](inResult);	
		}
		delete that.callBack[inOpCode];
	}
};

/*
文件上传
*/
function upload(url,file,cb){
	var obj={
        url:url,
        dataType:'text',
		type:'POST',
        cacheTime:0,
		data:{'file':{'path':file}},
        success:function(data){
            cb(data);
        }
    };
	ddRequest(obj);
}

/*
底部弹出对话框
*/
function actionSheet(menu,cancel,title,cb){
	if(typeof cancel=='undefined'){
		cancel='取消';
	}
	if(typeof title=='undefined'){
		title='';
	}
	if(cancel==''){
		cancel='取消';
	}
	uexWindow.actionSheet(title,cancel,menu);
	uexWindow.cbActionSheet = function(opId, dataType, data){
    	cb(data);
	};
}

/*
打开相机
*/
function openCamera(){
　　uexCamera.open();
}

/*
打开图片浏览
*/
function openImageBrowser(){
　　uexImageBrowser.pick();
}

/*
复制
*/
function clipboarSet(text){
	uexClipboard.copy(text);
}

/*
粘贴
*/
function clipboarGet(cb){
	uexClipboard.cbGetContent=function(opId,dataType,data){
		cb(data);
	}
	uexClipboard.getContent();
}

/*
启动分享页面
*/
function sharePage(shareTitle,shareDsc,shareImg,shareUrl){
	set('shareTitle',shareTitle);
	set('shareDsc',shareDsc);
	set('shareImg',shareImg);
	set('shareUrl',shareUrl);
	var extraInfo='{"extraInfo":{"opaque":"true","bgColor":"","delayTime":"0","hardware":"0"}}';
	var pageParame=get('pageParame');
	uexWindow.openPopover('share',0,'share.html',0,0,0,pageParame.windowW,pageParame.windowH,pageParame.fontSize,2,0,extraInfo);
}

/*
等待效果
dom是放在哪个节点里
w是宽度
h是高度
num是竖条个数
color是颜色
*/
function loadImg(dom,h,w,num,color){
	var kuan=w/num;
	var numW=kuan*0.7;
	var numL=kuan*0.3;
	var html='';
	var st=num*0.2;
	var _st=num*0.15;
	html='<div class="spinner" style="width: '+w+'em;height: '+h+'em;">';
	//html='<div class="spinner">';
	for(var i=1;i<=num;i++){
		st=st-0.1;
		st=st.toFixed(1);
		html+='<div class="rect'+i+'" style="-webkit-animation: stretchdelay '+_st+'s infinite ease-in-out;-webkit-animation-delay: -'+st+'s;background-color: '+color+';margin-right:'+numL+'em;width: '+numW+'em;"></div>';
	}
	html+='</div>';
	$(dom).html(html);
}

/*
弹窗函数
*/
function showPopup3(title,done,cancel,doneCallback,cancelCallback,message) {
	jq("body").popup({
		title: title,
		message: "<table id='popup3_login' style=' width:100%'><tr><td style=>帐号:</td><td><input type='text'></td></tr><tr><td>密码:</td><td><input type='text' class='af-ui-forms' style='webkit-text-security:disc'></td></tr></table>",
		cancelText: cancel,
		cancelCallback: function () {
			//cancelCallback();
		},
		doneText: done,
		doneCallback: function () {
			//doneCallback();
			//$('.afPopup #hide').click();
		},
        cancelOnly: false,
		autoCloseDone:false
	});
}

function ddalert(content){
	jq("body").popup({
		title: '内容详情',
		message: '<div class="ddalertdiv">'+content+'</div>',
		cancelText: 'OK',
		cancelCallback: function () {
			//cancelCallback();
		},
		doneText: '',
		doneCallback: function () {
			//doneCallback();
			//$('.afPopup #hide').click();
		},
        cancelOnly: true
	});
}

// crc32
(function() {  
    var table = "00000000 77073096 EE0E612C 990951BA 076DC419 706AF48F E963A535 9E6495A3 0EDB8832 79DCB8A4 E0D5E91E 97D2D988 09B64C2B 7EB17CBD E7B82D07 90BF1D91 1DB71064 6AB020F2 F3B97148 84BE41DE 1ADAD47D 6DDDE4EB F4D4B551 83D385C7 136C9856 646BA8C0 FD62F97A 8A65C9EC 14015C4F 63066CD9 FA0F3D63 8D080DF5 3B6E20C8 4C69105E D56041E4 A2677172 3C03E4D1 4B04D447 D20D85FD A50AB56B 35B5A8FA 42B2986C DBBBC9D6 ACBCF940 32D86CE3 45DF5C75 DCD60DCF ABD13D59 26D930AC 51DE003A C8D75180 BFD06116 21B4F4B5 56B3C423 CFBA9599 B8BDA50F 2802B89E 5F058808 C60CD9B2 B10BE924 2F6F7C87 58684C11 C1611DAB B6662D3D 76DC4190 01DB7106 98D220BC EFD5102A 71B18589 06B6B51F 9FBFE4A5 E8B8D433 7807C9A2 0F00F934 9609A88E E10E9818 7F6A0DBB 086D3D2D 91646C97 E6635C01 6B6B51F4 1C6C6162 856530D8 F262004E 6C0695ED 1B01A57B 8208F4C1 F50FC457 65B0D9C6 12B7E950 8BBEB8EA FCB9887C 62DD1DDF 15DA2D49 8CD37CF3 FBD44C65 4DB26158 3AB551CE A3BC0074 D4BB30E2 4ADFA541 3DD895D7 A4D1C46D D3D6F4FB 4369E96A 346ED9FC AD678846 DA60B8D0 44042D73 33031DE5 AA0A4C5F DD0D7CC9 5005713C 270241AA BE0B1010 C90C2086 5768B525 206F85B3 B966D409 CE61E49F 5EDEF90E 29D9C998 B0D09822 C7D7A8B4 59B33D17 2EB40D81 B7BD5C3B C0BA6CAD EDB88320 9ABFB3B6 03B6E20C 74B1D29A EAD54739 9DD277AF 04DB2615 73DC1683 E3630B12 94643B84 0D6D6A3E 7A6A5AA8 E40ECF0B 9309FF9D 0A00AE27 7D079EB1 F00F9344 8708A3D2 1E01F268 6906C2FE F762575D 806567CB 196C3671 6E6B06E7 FED41B76 89D32BE0 10DA7A5A 67DD4ACC F9B9DF6F 8EBEEFF9 17B7BE43 60B08ED5 D6D6A3E8 A1D1937E 38D8C2C4 4FDFF252 D1BB67F1 A6BC5767 3FB506DD 48B2364B D80D2BDA AF0A1B4C 36034AF6 41047A60 DF60EFC3 A867DF55 316E8EEF 4669BE79 CB61B38C BC66831A 256FD2A0 5268E236 CC0C7795 BB0B4703 220216B9 5505262F C5BA3BBE B2BD0B28 2BB45A92 5CB36A04 C2D7FFA7 B5D0CF31 2CD99E8B 5BDEAE1D 9B64C2B0 EC63F226 756AA39C 026D930A 9C0906A9 EB0E363F 72076785 05005713 95BF4A82 E2B87A14 7BB12BAE 0CB61B38 92D28E9B E5D5BE0D 7CDCEFB7 0BDBDF21 86D3D2D4 F1D4E242 68DDB3F8 1FDA836E 81BE16CD F6B9265B 6FB077E1 18B74777 88085AE6 FF0F6A70 66063BCA 11010B5C 8F659EFF F862AE69 616BFFD3 166CCF45 A00AE278 D70DD2EE 4E048354 3903B3C2 A7672661 D06016F7 4969474D 3E6E77DB AED16A4A D9D65ADC 40DF0B66 37D83BF0 A9BCAE53 DEBB9EC5 47B2CF7F 30B5FFE9 BDBDF21C CABAC28A 53B39330 24B4A3A6 BAD03605 CDD70693 54DE5729 23D967BF B3667A2E C4614AB8 5D681B02 2A6F2B94 B40BBE37 C30C8EA1 5A05DF1B 2D02EF8D";    
    /* Number */  
    crc32 = function( /* String */ str, /* Number */ crc ) {  
        if( crc == window.undefined ) crc = 0;  
        var n = 0; //a number between 0 and 255  
        var x = 0; //an hex number  
        crc = crc ^ (-1);  
        for( var i = 0, iTop = str.length; i < iTop; i++ ) {  
            n = ( crc ^ str.charCodeAt( i ) ) & 0xFF;  
            x = "0x" + table.substr( n * 9, 8 );  
            crc = ( crc >>> 8 ) ^ x;  
        }  
        var r= crc ^ (-1);  
		if(r<0){
			r=r>>>0;
		}
		return r;
	};  
})();

/*
catch网址的函数
*/
var onOAuth={
	'weblogin':function(winNam, url){
		if(url.indexOf('php?m=show_code_uid&code_uid=')>0){
			var urlArr=url.split('php?m=show_code_uid&code_uid=');
			var codeUid=urlArr[1];
			alert(codeUid);
		}
	}
}

function openList(goods_canshu){
	/*if(!String(goods_canshu)){
		var str='';
		for(var i in goods_canshu){
			str+='&'+i+'='+urlencode(goods_canshu[i]);
		}
		goods_canshu=str.replace(/^&/,'')
	}*/
	set('goods_canshu',goods_canshu);
	wescript('page_root','changeFoot(1)');publish('page_root','goods');
}

function click_jump(id){
	set('id',id);
	openWin('page_view');
}

function openView(id){
	set('goods_id',id);
	openPage('goods_view');
}

function setPageTitle(title){
	wescript(get('curWinName'),'setTitle("'+title+'")');
}
function checkIos7(){
	var ios7style=uexWidgetOne.iOS7Style;
    var isFullScreen = uexWidgetOne.isFullScreen;
    if (ios7style == '1' && isFullScreen != '1') {
		set('ios7',1);
		$("#ios7h").css("height",'20px');
    }
}
/*获取模板函数*/
function getTpl(_function){
	var tpl=_function.toString();
	tpl=tpl.replace(/function\s*\w+\s*\(\)\s*{\/\*/,'').replace(/\*\/;}$/,'');
	return tpl;
	//alert(tpl.match(/^[\w]+\snav_tpl\(\)\{\s+\/\*([\w\s*\/\\<>'"=#;:$.()]+)\*\/\s+\}$/i)[1]);
}
function curl(p,type){
	var time=0;
	type=type||1;
	p=p||0;
	if(p>0){
		page=p;
		$('#goodsSection').html('');
	}
	$nextPage=$('#getmore');
	var nextWait=ddInt($nextPage.attr('wait'));
	var nextWord=$nextPage.text();
	if(nextWait=='0'){
		$('#nextPage .text').text('数据获取中……');
		$('#nextPage').attr('wait','1');
	}
	else{
		return false;
	}
	var url=apiUrl+page;
	var row='';
	
	var obj={
		url:url,
		dataType:'json',
		cacheTime:time,
		tip:'数据获取中',
		success:function(data){
			if(data.r=='' || data.r=='null' || data.r==null){
				if(typeof pageNullTip!='undefined'){
					if(pageNullTip==1){
						var h='<div class="pageNullTip">暂无数据</div>';
					}
					else{
						var h=pageNullTip;
					}
					$('#loadtip').hide();
					if(page==1){
						$('#sectiondiv').html(h);
					}
					$nextPage.hide();
				}
				toastOpen('没有了');
			}
			else{
				for(i in data.r){
					row=data.r[i];
					var html=getTplObj(index_tpl,row);
					if(type==1){
						$('#sectiondiv').append(html);
					}
					else if(type==2){
						$('#sectiondiv').prepend(html);
					}
				
					if(page==1){
						$nextPage.show();
					}
					$('#loadtip').hide();
					/*if(typeof row.img!='undefined'){
						imgId='img-'+row.id;
						dataSrc=row.img;
						zy_imgcache(imgId,dataSrc);
					}*/
				}
				page++;
			}
			$nextPage.attr('wait','0');
			$nextPage.find('.text').text(nextWord);
		}
	};
	ddRequest(obj);
}

function ddList(id,data,page,fun){
	if(page==1){
		window.listObj={};
		listObj = appcan.listview({
			selector : "#"+id,
			type : "thickLine",
			hasIcon : false,
			hasAngle : true,
			hasSubTitle : true,
			multiLine : 1
		});
		listObj.set(data);
		
		listObj.on("click", function(obj, data,subObj) {
			fun(data);
		});
	}
	else{
		listObj.add(data,1);
	}
}

function ddcurl(page,apiUrl){
	page=page||0;
	if(page==0){
		page=get('user_page');
	}
	apiUrl=apiUrl||'';
	if(apiUrl==''){
		apiUrl=get('user_apiUrl');
	}
	else{
		set('user_apiUrl',apiUrl);
	}
	var url=apiUrl+page;
	$('#getmore').hide();
	var obj={
		url:url,
		dataType:'json',
		tip:'数据获取中',
		success:function(data){
			if(size(data.r)==0){
				data.s=0;
			}
			ddList('list_data',data.r,page,function(data){ddalert(data.des);});
			if(data.s==1){
				page++;
				set('user_page',page);
				$('#getmore').show();
			}
			else{
				toastOpen('没有了');
				$('#getmore').hide();
				if(page==1){
					$('#list_data').html('<div style="text-align:center; color:#666; font-size:1em; padding-top:2em">暂无数据！</div>');
				}
				else{
					toastOpen('没有了');
				}
			}
		}
	};
	ddRequest(obj);
}

/*
模板引擎，现支持循环，变量，对象的解析
*/
function jiexiTpl(data,obj){
	if(data!=''){
		var WEBSET=get('WEBSET');
		var a=data.match(/<\{\$\w+\}>([\s\S])+?<\{\/\$\w+\}>/ig);
		if(a!=null){
			for(var i in a){
				var v=a[i];
				var name='ddfuntpl'+getPID()
				data=data.replace(v,name);
				var b=v.match(/<\{\$(\w+)\}>/i);
				v=v.replace('<\{\$'+b[1]+'\}>','').replace('<{/$'+b[1]+'}>','');
				v=$.trim(v);
				if(typeof b[1]!='undefined' && typeof obj[b[1]]!='undefined' && obj[b[1]]!=''){
					v=getTplObj(v,obj[b[1]]);
					data=data.replace(name,v);
				}
				else{
					data=data.replace(name,'');
				}
			}
		}
		
		var a=data.match(/<\{\$([\w-.])+?\}>/ig);
		if(a!=null){
			for(var i in a){
				var b=a[i].replace('<{$','').replace('}>','');
				var pattern = "<\{\\$"+b+"+\}>";
				var reg = new RegExp(pattern, "g");
				if(b.indexOf('.')>0){
					b=b.split('.');
					if(b[0]=='WEBSET'){
						v=WEBSET[b[1]];				
					}
					else{
						var v=obj[b[0]][b[1]];
					}
				}
				else{
					var v=obj[b];
				}
				data=data.replace(reg,v);
			}
		}
	}
	return data;
}

function getTplObj(tpl,obj){
	var _tpl='';
	var str='';
	if(obj.hasOwnProperty('0')==false){
		_tpl=tpl;
		for(var j in obj){
			var pattern = "<\{\\$"+j+"\}>";
			var reg = new RegExp(pattern, "g");
			if(typeof obj[j]!='undefined'){
				var tmp=obj[j];
			}
			else{
				var tmp='';
			}
			_tpl=_tpl.replace(reg,tmp);
		}
		str=_tpl;
	}
	else{
		for(i in obj){
			_tpl=tpl;
			var a=_tpl.match(/{#cur=(\d+)}(.*){\/#cur}/);
			if(a!=null){
				if(a[1]==i){
					_tpl=_tpl.replace(a[0],a[2]);
				}
				else{
					_tpl=_tpl.replace(a[0],'');
				}
			}
			
			var jishu=0;
			for(var j in obj[i]){
				var pattern = "<\{\\$"+j+"\}>";
				var reg = new RegExp(pattern, "g");
				if(typeof obj[i][j]!='undefined'){
					var tmp=obj[i][j];
				}
				else{
					var tmp='';
				}
				_tpl=_tpl.replace(reg,tmp);
				jishu++;
			}
			str+=_tpl;
		}
	}
	return str;
}

function tplOnce(tpl){
	if(typeof tpl=='undefined'){
		alert(WIN_NAME+':tpl error');
		return false;
	}
	var js=tpl.match(/<script>([\s\S])+?<\/script>/);
	if(js==null){
		js='';
	}
	else{
		js=js[0];
	}
	var css=tpl.match(/<style>([\s\S])+?<\/style>/);
	if(css==null){
		css='';
	}
	else{
		css=css[0];
	}
	var html=tpl.replace(/<script>([\s\S])+?<\/script>/ig,'').replace(/<style>([\s\S])+?<\/style>/ig,'');
	var _html=html;
	html=html.replace(/<\{\$\w+\}>([\s\S])+?<\{\/\$\w+\}>/ig,'');
	html=html.replace(/<\{\$[\w-.]+\}>/ig,'');
	tpl={'html':html,'_html':_html,'js':js,'css':css}
	return tpl;
}

/*
select的option选择器
*/
function selectOption(dom){
	var a={};
	$(dom).each(function(index){
		if($(this).attr('selected')==true){
			a=$(this)
		}
	});
	return a;
}

/*
模拟器下定义uexMJWebBrowser
*/

if(typeof uexMJWebBrowser=='undefined'){
	var uexMJWebBrowser={'intercept':function(){},'cbOpen':function(){},'execJs':function(){},'close':function(){},'open':function(url){
		openFrame('page_view',url)
	}}
}

/*
打开窗口之前先判断是否登录 
*/
function openPageUser(name,url,type,title){
    type=type||'html';
    url=url||'';
    title=title||'';
    var user=get('DD_User');
    if(typeof user.id=='undefined' || ddInt(user.id)==0){
        set('from','user');
        openPage('user_login');
    }
    else{
        openPage(name,url,type,title);
    }
}

/*
打开自定义窗口 
*/
function openPage_x(mod,act){
    set('ddmod',mod);
	set('ddact',act);
	openPage('x_x');
}